#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

#include "clock_linux_counter.h" /* _SC_LINUX_COUNTER_HZ */

#define NAME(s) { #s, _SC_##s }
#define NAME_(s) { #s, _SC##s }

struct name {
  char *str;
  int i;
} name[] = {

NAME(ARG_MAX),
NAME(ATEXIT_MAX),
NAME(BC_BASE_MAX),
NAME(BC_DIM_MAX),
NAME(BC_SCALE_MAX),
NAME(BC_STRING_MAX),
NAME(CHILD_MAX),
NAME(CLK_TCK),
NAME(COLL_WEIGHTS_MAX),
NAME(EXPR_NEST_MAX),
{ "IOV_MAX", _SC_T_IOV_MAX },
NAME(LINE_MAX),
#if 0
NAME(LOGNAME_MAX),
#endif
NAME(NGROUPS_MAX),
NAME(OPEN_MAX),
NAME(PAGESIZE),
NAME(PAGE_SIZE),
NAME(PASS_MAX),
{ "POSIX2_VERSION", _SC_2_VERSION },
NAME(RE_DUP_MAX),
NAME(STREAM_MAX),
NAME(TIMER_MAX),
NAME(TZNAME_MAX),
{ "POSIX2_CHAR_TERM", _SC_2_CHAR_TERM },
{ "POSIX2_C_BIND", _SC_2_C_BIND },
{ "POSIX2_C_DEV", _SC_2_C_DEV },
{ "POSIX2_C_VERSION", _SC_2_C_VERSION },
{ "POSIX2_FORT_DEV", _SC_2_FORT_DEV },
{ "POSIX2_FORT_RUN", _SC_2_FORT_RUN },
{ "POSIX2_LOCALEDEF", _SC_2_LOCALEDEF },
{ "POSIX2_SW_DEV", _SC_2_SW_DEV },
{ "POSIX2_UPE", _SC_2_UPE },
{ "_POSIX2_CHAR_TERM", _SC_2_CHAR_TERM },
{ "_POSIX2_C_BIND", _SC_2_C_BIND },
{ "_POSIX2_C_DEV", _SC_2_C_DEV },
{ "_POSIX2_C_VERSION", _SC_2_C_VERSION },
{ "_POSIX2_FORT_DEV", _SC_2_FORT_DEV },
{ "_POSIX2_FORT_RUN", _SC_2_FORT_RUN },
{ "_POSIX2_LOCALEDEF", _SC_2_LOCALEDEF },
{ "_POSIX2_SW_DEV", _SC_2_SW_DEV },
{ "_POSIX2_UPE", _SC_2_UPE },
{ "_POSIX2_VERSION", _SC_2_VERSION },
{ "_POSIX_JOB_CONTROL", _SC_JOB_CONTROL },
{ "_POSIX_SAVED_IDS", _SC_SAVED_IDS },
{ "_POSIX_VERSION", _SC_VERSION },
NAME_(_XOPEN_CRYPT),
NAME_(_XOPEN_ENH_I18N),
NAME_(_XOPEN_SHM),
NAME_(_XOPEN_UNIX),
NAME_(_XOPEN_VERSION),
NAME_(_XOPEN_XCU_VERSION),
#if 0
NAME(ABI_ASYNCHRONOUS_IO),
NAME(ACL),
NAME(AUDIT),
NAME(CAP),
NAME(INF),
NAME(IP_SECOPTS),
NAME(KERN_POINTERS),
NAME(KERN_SIM),
NAME(MAC),
NAME(NACLS_MAX),
#endif
{ "NPROC_CONF", _SC_NPROCESSORS_CONF },
{ "NPROC_ONLN", _SC_NPROCESSORS_ONLN },
#if 0
NAME(SOFTPOWER),
#endif
NAME(AIO_LISTIO_MAX),
NAME(AIO_MAX),
NAME(AIO_PRIO_DELTA_MAX),
NAME(DELAYTIMER_MAX),
NAME(MQ_OPEN_MAX),
NAME(MQ_PRIO_MAX),
NAME(RTSIG_MAX),
NAME(SEM_NSEMS_MAX),
NAME(SEM_VALUE_MAX),
NAME(SIGQUEUE_MAX),
{ "_POSIX_ASYNCHRONOUS_IO", _SC_ASYNCHRONOUS_IO },
{ "_POSIX_FSYNC", _SC_FSYNC },
{ "_POSIX_MAPPED_FILES", _SC_MAPPED_FILES },
{ "_POSIX_MEMLOCK", _SC_MEMLOCK },
{ "_POSIX_MEMLOCK_RANGE", _SC_MEMLOCK_RANGE },
{ "_POSIX_MEMORY_PROTECTION", _SC_MEMORY_PROTECTION },
{ "_POSIX_MESSAGE_PASSING", _SC_MESSAGE_PASSING },
{ "_POSIX_PRIORITIZED_IO", _SC_PRIORITIZED_IO },
{ "_POSIX_PRIORITY_SCHEDULING", _SC_PRIORITY_SCHEDULING },
{ "_POSIX_REALTIME_SIGNALS", _SC_REALTIME_SIGNALS },
{ "_POSIX_SEMAPHORES", _SC_SEMAPHORES },
{ "_POSIX_SHARED_MEMORY_OBJECTS", _SC_SHARED_MEMORY_OBJECTS },
{ "_POSIX_SYNCHRONIZED_IO", _SC_SYNCHRONIZED_IO },
{ "_POSIX_TIMERS", _SC_TIMERS },
NAME(GETPW_R_SIZE_MAX),
NAME(GETPW_R_SIZE_MAX),
NAME(LOGIN_NAME_MAX),
NAME(THREAD_DESTRUCTOR_ITERATIONS),
NAME(THREAD_KEYS_MAX),
NAME(THREAD_STACK_MIN),
NAME(THREAD_THREADS_MAX),
NAME(TTY_NAME_MAX),
{ "_POSIX_THREADS", _SC_THREADS },
{ "_POSIX_THREAD_ATTR_STACKADDR", _SC_THREAD_ATTR_STACKADDR },
{ "_POSIX_THREAD_ATTR_STACKSIZE", _SC_THREAD_ATTR_STACKSIZE },
{ "_POSIX_THREAD_PRIORITY_SCHEDULING", _SC_THREAD_PRIORITY_SCHEDULING },
{ "_POSIX_THREAD_PRIO_INHERIT", _SC_THREAD_PRIO_INHERIT },
{ "_POSIX_THREAD_PRIO_PROTECT", _SC_THREAD_PRIO_PROTECT },
{ "_POSIX_THREAD_PROCESS_SHARED", _SC_THREAD_PROCESS_SHARED },
{ "_POSIX_THREAD_SAFE_FUNCTIONS", _SC_THREAD_SAFE_FUNCTIONS },
#if 0
NAME(MMAP_FIXED_ALIGNMENT),
#endif
NAME_(_XBS5_ILP32_OFF32),
NAME_(_XBS5_ILP32_OFFBIG),
NAME_(_XBS5_LP64_OFF64),
NAME_(_XBS5_LPBIG_OFFBIG),
NAME_(_XOPEN_LEGACY),
NAME_(_XOPEN_REALTIME),
NAME(CHAR_BIT),
NAME(CHAR_MAX),
NAME(CHAR_MIN),
NAME(CHARCLASS_NAME_MAX),
NAME(INT_MAX),
NAME(INT_MIN),
NAME(LONG_BIT),
#if 0
NAME(LONG_MAX),
NAME(LONG_MIN),
#endif
NAME(MB_LEN_MAX),
NAME(NL_ARGMAX),
NAME(NL_LANGMAX),
NAME(NL_NMAX),
NAME(NL_MSGMAX),
NAME(NL_SETMAX),
NAME(NL_TEXTMAX),
NAME(NZERO),
{ "POSIX2_BC_BASE_MAX", _SC_BC_BASE_MAX },
{ "POSIX2_BC_DIM_MAX", _SC_BC_DIM_MAX },
{ "POSIX2_BC_SCALE_MAX", _SC_BC_SCALE_MAX },
{ "POSIX2_BC_STRING_MAX", _SC_BC_STRING_MAX },
{ "POSIX2_COLL_WEIGHTS_MAX", _SC_COLL_WEIGHTS_MAX },
{ "POSIX2_EXPR_NEST_MAX", _SC_EXPR_NEST_MAX },
{ "POSIX2_LINE_MAX", _SC_LINE_MAX },
{ "POSIX2_RE_DUP_MAX", _SC_RE_DUP_MAX },
{ "_POSIX_ARG_MAX", _SC_ARG_MAX },
{ "_POSIX_CHILD_MAX", _SC_CHILD_MAX },
#if 0
{ "_POSIX_LINK_MAX", _PC_LINK_MAX },
{ "_POSIX_MAX_CANON", _PC_MAX_CANON },
{ "_POSIX_MAX_INPUT", _PC_MAX_INPUT },
{ "_POSIX_NAME_MAX", _PC_NAME_MAX },
#endif
{ "_POSIX_NGROUPS_MAX", _SC_NGROUPS_MAX },
{ "_POSIX_OPEN_MAX", _SC_OPEN_MAX },
#if 0
{ "_POSIX_PATH_MAX", _PC_PATH_MAX },
{ "_POSIX_PIPE_BUF", _PC_PIPE_BUF },
#endif
{ "_POSIX_SSIZE_MAX", _SC_SSIZE_MAX },
{ "_POSIX_STREAM_MAX", _SC_STREAM_MAX },
{ "_POSIX_TZNAME_MAX", _SC_TZNAME_MAX },
NAME(SCHAR_MAX),
NAME(SCHAR_MIN),
NAME(SHRT_MAX),
NAME(SHRT_MIN),
NAME(SSIZE_MAX),
#if 0
NAME(TMP_MAX),
#endif
NAME(UCHAR_MAX),
NAME(UINT_MAX),
NAME(ULONG_MAX),
NAME(USHRT_MAX),
NAME(WORD_BIT),
{ "_XOPEN_IOV_MAX", _SC_T_IOV_MAX },
#if 0
NAME_(_ABI_AIO_XFER_MAX),
#endif
{ "_POSIX_AIO_LISTIO_MAX", _SC_AIO_LISTIO_MAX },
{ "_POSIX_AIO_MAX", _SC_AIO_MAX },
{ "_POSIX_DELAYTIMER_MAX", _SC_DELAYTIMER_MAX },
{ "_POSIX_MQ_OPEN_MAX", _SC_MQ_OPEN_MAX },
{ "_POSIX_MQ_PRIO_MAX", _SC_MQ_PRIO_MAX },
{ "_POSIX_RTSIG_MAX", _SC_RTSIG_MAX },
{ "_POSIX_SEM_NSEMS_MAX", _SC_SEM_NSEMS_MAX },
{ "_POSIX_SEM_VALUE_MAX", _SC_SEM_VALUE_MAX },
{ "_POSIX_SIGQUEUE_MAX", _SC_SIGQUEUE_MAX },
{ "_POSIX_TIMER_MAX", _SC_TIMER_MAX },
#if 0
{ "_POSIX_CLOCKRES_MIN", _SC_CLOCKRES_MIN },
#endif
{ "_POSIX_LOGIN_NAME_MAX", _SC_LOGIN_NAME_MAX },
{ "_POSIX_THREAD_DESTRUCTOR_ITERATIONS", _SC_THREAD_DESTRUCTOR_ITERATIONS },
{ "_POSIX_THREAD_KEYS_MAX", _SC_THREAD_KEYS_MAX },
{ "_POSIX_THREAD_THREADS_MAX", _SC_THREAD_THREADS_MAX },
{ "_POSIX_TTY_NAME_MAX", _SC_TTY_NAME_MAX },
#if 0
NAME(LONGLONG_MAX),
NAME(LONGLONG_MIN),
NAME(ULONGLONG_MAX),
NAME(VENDOR),
NAME(OS_PROVIDER),
NAME(OS_NAME),
NAME(HW_NAME),
#endif
{ "NUM_PROCESSORS", _SC_NPROCESSORS_CONF },

NAME(LINUX_COUNTER_HZ),

#if 0
NAME(HOSTID),
NAME(OSREL_MAJ),
NAME(OSREL_MIN),
NAME(OSREL_PATCH),
NAME(PROCESSORS),
NAME(AVAIL_PROCESSORS),
NAME(PATH),
NAME(CS_PATH),
NAME(_CS_PATH),
NAME(SYSNAME),
NAME(HOSTNAME),
NAME(RELEASE),
NAME(VERSION),
NAME(MACHINE),
NAME(ARCHITECTURE),
NAME(HW_SERIAL),
NAME(HW_PROVIDER),
NAME(SRPC_DOMAIN),
NAME(INITTAB_NAME)
#endif
};

int nof_names = sizeof(name)/sizeof(struct name);

int main(void)
{
  int i;
  long ret;

  for (i = 0; i < nof_names; i++) {
    errno = 0;
    ret = sysconf(name[i].i);
    if (ret == -1) {
      if (errno == EINVAL) {
	fprintf(stderr, "sysconf(%s) failed: %s\n", name[i].str, strerror(errno));
      }
      else {
	printf("%-32s Not supported\n", name[i].str);
      }
    }
    else {
      printf("%-32s %ld\n", name[i].str, ret);
    }
  }
  return 0;
}
